
// Il ciclo for

public class Esempio1Sol {

	static int i;
	static int soglia;
	static int primo;
	static int n;
	static int m;
	static int divisore = m;
	
	public static void main(String[] args) {
		
		// Ecco un ciclo "for".
		// È una variante del while, che di solito viene usata
		// quando una variabile indice come i deve essere inizializzata (i=0),
		// incrementata (i++) ad ogni iterazione, fintanto che una condizione
		// (i <= soglia) rimane vera.
		soglia = 10;
		for (i=0 ; i <= soglia ; i++) {
			System.out.println("i = " + i);
		}
		
		// Il for è perfettamente equivalente a
		i=0;
		while (i <= soglia) {
			System.out.println("i = " + i);
			i++;
		}
		// e quindi non aggiunge nessuna funzionalità -- è solo una sintassi
		// più semplice per dire "i va da 0 a soglia".
		
		// Esercizio 1.
		// Usate un for per stampare i primi 20 quadrati.
		// 0 1 4 9 ...
		
		// Soluzione
		
		for (i=0 ; i<20 ; i++) {
			System.out.println("Il quadrato di " + i + " è " + (i*i));
		}
		
		// Esercizio 2.
		// Dato n>=2, verificate se n è un primo, provando
		// per esempio a dividerlo per tutti gli m tra 2 e n-1.
		// Usate l'operatore modulo a%b .

		// Soluzione
		
		n = 5;
		primo = 1;
		for (m=2 ; m<n ; m++) {
			if (n % m == 0) {
				primo = 0;
			}
		}
		
		if (primo == 1) {
			System.out.println("Il numero " + n + " è primo!");
		} else {
			System.out.println("Il numero " + n + " NON è primo!");
		}
		
		// Esercizio 3.
		// Per ogni n tra 2 e 100 stampate se è primo o no.
		// Se n è composto, stampate anche un suo divisore.
		
		// Soluzione (riusando il codice della soluzione precedente)

		for (n=2 ; n<=100 ; n++) {
			primo = 1;
			for (m=2 ; m<n ; m++) {
				if (n % m == 0) {
					primo = 0;
					divisore = m;
				}
			}
			
			if (primo == 1) {
				System.out.println("Il numero " + n + " è primo!");
			} else {
				System.out.println("Il numero " + n + " NON è primo, ma divisibile per " + divisore);
			}			
		}
	}
}
